
#include "\c\lat\dos.h"         /* contains definition of REGS */

/******************************************************************************
		SAMPLE FOREGROUND PROGRAM

This is a one line word processor. Each key pressed is echoed to the screen.
Pressing "enter" causes the screen to clear.

Pressing F1 causes a count of 1 to 100 to appear on the screen.

Pressing F10 returns to DOS

Note that this program is not directly compilable since it uses third party
functions that are not included.

If bomb detector is running, then this program should be executed with command line argument "test_mode", example:

"bomb foregnd.exe test_mode"

Otherwise it can be executed just as:

"foregnd.exe"

The reason for "test_mode" is that this enables us to pull certain interrupts used by the bomb detector breakpoint capability. If
we pull these interrupts without bomb detector running the foreground program would vanish into never-never land.

If no breakpoint interrupts are to be used then the argument "test_mode" is not necessary and we can simple execute:

"bomb foregnd.exe"

Avoid at all costs the command

"foregnd.exe test_mode"

since this will pull the interrupts without bomb detector having defined them.
*******************************************************************************/
void main(argc,argv)
int argc;
char *argv[];
{

int test_mode = 0;	       /* if this flag is set, then we have detected "test_mode" on the command line */
char scan;
int key,i;
union REGS outregs,inregs;


if (!stricmp(argv[1],"test_mode"))
    {
    printf("got here\n");
    test_mode = 1;
    }

while(1)
    {
    clrscrn();				     /* clear entire screen */
    VdspLS(1,1,"                 SAMPLE FOREGROUND PROGRAM \"foregnd.exe\"");
    curlocat(3,0);								  /* start on third row */
    scattrib(0,7,' ',80);
    curtype(0,12,13);
    while(1)
	{
	if (test_mode)				   /* don't pull bomb detector interrupts unless bomb detector is
						      running
						    */
	    {
	    int86(0xfe, &inregs, &outregs);		 /* clear previous breakpoint */
	    }
	scan =kbin(&key);
	if (test_mode)
	    {
	    int86(0xff, &inregs, &outregs);		 /* test for breakpoint */
	    if (outregs.x.ax == 1) breakpoint();
	    }
	if (scan == 1 && key == 13)		   /* restart if enter */
	    {
	    break;
	    }
	else if (scan == 0 && key == 68)	  /* F10 exits to DOS */
	    {
	    exit(0);
	    }
	else if (scan == 0 && key == 59)		/* if F1 then count 1-100 */
	    {
	    i = 1;
	    while (i <= 100)
		{
		printf("count = %d\n",i);
		SyWait(7);			    /* wait 60 ms between prints to assure correct scroll capture */
		i++;
		}
	    }
	else printf("%c",key);                      /* if none of above, do
						       edit (i.e. simply
						       edit key */
	}
    }
}

breakpoint()
{
}
