goto start
:usage
@echo off
echo Ŀ
echo  sda_id.bat -- Builds SDA.ID file for submitting       
echo                product to Software Distribution        
echo                Network (SDN, run by Ray Kaliss).       
echo                Also prepares checklist and required    
echo                submission form in SDNPRINT.TMP.        
echo                                                        
echo  usage:                                                
echo         sda_id vendinfo_file                           
echo  where:                                                
echo         vendinfo_file = pathname of VENDINFO.DIZ file  
echo                                                        
echo  example:                                              
echo     sda_id C:\VENDINFO.DIZ                             
echo                                                        
echo  NOTE: Invoke in directory in which you want {SDA.ID}. 
echo        Remember to print and delete SDNPRINT.TMP.      
echo        VENDPRCS.EXE must be on your DOS path.          
echo                                                        
echo  From the VNDUTL VENDINFO Utilities, v1.02 (7/27/94)   
echo  Copyright 1994 Rams' Island Software, Parker, CO USA  
echo 
goto done

::----- check arguments -------------------------------------------
::-----    first argument must VENDINFO file pathname -------------
:start
if %1. == .        goto usage
if not exist %1    goto problem
goto argsOK

:argsOK
::----- test VENDINFO file ----------------------------------------   
vendprcs %1 -xppt
if errorlevel 52 goto viFileOK
goto problem

:viFileOK
::----- build {SDA.ID} program description file -------------------   
vendprcs %1 -xpd1 > {SDA.ID}
vendprcs %1 -zn -xpk -y "1-XXXX MMMYY @" >> {SDA.ID}
vendprcs %1 -xamb -zn -zt " {ASAD}" -na >> {SDA.ID}
vendprcs %1 -xama -zn -zt " {ASP}"  -na >> {SDA.ID}
vendprcs %1 -xame -zn -zt " {ESC}"  -na >> {SDA.ID}
vendprcs %1 -xams -zn -zt " {STAR}" -na >> {SDA.ID}
vendprcs -y " " >> {SDA.ID}
vendprcs %1 -xppl -y "FILES: @.SDN" >> {SDA.ID}
vendprcs -y " " >> {SDA.ID}
vendprcs %1 -xac -y "Author: @" >> {SDA.ID}
vendprcs %1 -xi1p -zn -y "Registration: @" >> {SDA.ID}
vendprcs %1 -xic -y " (@)" >> {SDA.ID}
vendprcs -y " " >> {SDA.ID}
vendprcs %1 -xpd -zr80 -zc75 >> {SDA.ID}

::----- print required submission form ----------------------------   
echo ============================================================================ > SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo                SDN International (sm) PROGRAM FORM - 1/94 revision >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
vendprcs %1 -xpp -zn -y "NAME/VERSION OF THE SOFTWARE PACKAGE: @ v" >> SDNPRINT.TMP
vendprcs %1 -xpv >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo (Print your name and mailing address below) >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
vendprcs %1 -xac -y "AUTHOR:  @" >> SDNPRINT.TMP
vendprcs %1 -xaa -zi9 >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo I request SDN distribute the software program above, certify that it >> SDNPRINT.TMP
echo meets SDN's criteria and release SDN from distribution liability. >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
vendprcs -xxd -zn -y "SIGNED: __________________________  DATE: @  " >> SDNPRINT.TMP
vendprcs %1 -xaq -y "PHONE: @" >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo Did you include an SASE and support? >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo MAIL TO: SDN International, 13 Douglas Drive, Meriden, CT. 06451  U.S.A. >> SDNPRINT.TMP
echo ============================================================================ >> SDNPRINT.TMP
echo                                    Produced from VENDINFO.DIZ by VNDUTL 1.02 >> SDNPRINT.TMP
echo  >> SDNPRINT.TMP
echo ============================================================================ >> SDNPRINT.TMP
echo Checklist of preparation steps for Software Distribution Network submission: >> SDNPRINT.TMP
echo ============================================================================ >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] If this is your first SDN submission, review the SDN documentation >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Invoke an ASCII text editor on the {SDA.ID} file you've created >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] In line 2, change 1-XXXX to preferred SDN File Area from AREATAG.LST >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] In line 2, change MMMYY to SUBMISSION month & year, as JUL94 >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] If line 2 is wider than 75 characters, shorten it to that width >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] In line 3, verify package name(s) correct, end in SDN, as MYPROG11.SDN >> SDNPRINT.TMP
echo         NOTE: if product has multiple packages, manual correction NECESSARY >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] If line 1 or product description contains (Part 1 of 2) or similar >> SDNPRINT.TMP
echo      text, remove it.  {SDA.ID} describes whole product, not package. >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Look over entire file, making sure it's all as you want it >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Place your package(s) on diskette(s) as described in SDN documentation >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Copy the {SDA.ID} file onto first diskette of your SDN submission >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Prepare package including: >> SDNPRINT.TMP
echo         [ ] Diskette(s) >> SDNPRINT.TMP
echo         [ ] Signed permission form >> SDNPRINT.TMP
echo         [ ] Stamped, self-addressed envelope >> SDNPRINT.TMP
echo         [ ] Optional contribution to SDN, if desired >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo  [ ] Send package to: >> SDNPRINT.TMP
echo         SDN International >> SDNPRINT.TMP
echo         13 Douglas Drive >> SDNPRINT.TMP
echo         Meriden, CT. 06451 >> SDNPRINT.TMP
echo         U.S.A. >> SDNPRINT.TMP
vendprcs -y " " >> SDNPRINT.TMP
echo ============================================================================ >> SDNPRINT.TMP
echo                                                      Produced by VNDUTL 1.02 >> SDNPRINT.TMP
goto done

:problem
@echo off
cls
echo Specified VENDINFO file
echo    (%1)
echo does not exist, or is corrupted, unregistered, or has some other
echo difficulty.

:done
