****
**** RESTlib public domain release March 1, 1995 (Jayson R. Minard)
****
**** ---- --- These comments may not be removed! --- ----
****
**** original RESTlib (c) 1993-95 Jayson R. Minard
****                          CIS 72124,2343
****                         iNET jayson@jerm.com
****
****
**** This code may be used for any purpose as long as credit for the
**** originating code is given back to Jayson Minard within the resulting
**** product or its documentation.
****

#INCLUDE KEYS.HDR
#INCLUDE RESTLIST.HDR
#INCLUDE RESTMISC.HDR
#INCLUDE IO.HDR
#INCLUDE SYSTEM.HDR

VARDEF EXTERN
  INT __last_key
ENDDEF


FUNCTION INT Default_Key_Handler
  PARAMETERS VALUE LONG list_handle,;
             VALUE UINT list_element,;
                   UINT mouse_stat,;
             VALUE UINT mrow,;
             VALUE UINT mcol,;
                    INT pick_key,;
             VALUE UINT top_element,;
             VALUE UINT last_element,;
             VALUE UINT ur,;
             VALUE UINT uc,;
             VALUE UINT lr,;
             VALUE UINT lc,;
             VALUE UINT scroll_col

  VARDEF
    INT  list_return
  ENDDEF

  list_return = &jl_continue

  DO CASE
    CASE mouse_stat = &jl_mouse_ignore
    CASE mouse_stat = &jl_mouse_right    && right button pressed
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_xright   && right button released
      __last_key = &k_esc
      pick_key = &k_esc

    CASE mouse_stat = &jl_mouse_up       && left button + top scroll-bar tab
      pick_key = &k_up
    CASE mouse_stat = &jl_mouse_xup      && left button release "     "
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_down     && left button + bottom scroll tab
      pick_key = &k_down
    CASE mouse_stat = &jl_mouse_xdown    && left button release "     "
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_xscroll
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_scroll
      && cursor on scroll_bar, the default
      && 'pick_key' values should be set.
      &&    at bottom of list = &k_c_pg_down
      &&    at top of list    = &k_c_pg_up
      &&    above current     = &k_pg_down
      &&    below current     = &k_pg_up

      *- the values of 'pick_key' are set based upon the position of the
      *  mouse cursor relative to the scroll bar marker.
      *
      *  leave them as-is for now...  You can change this to change the
      *  default for them.
      *
      DO CASE
        CASE pick_key = &k_pg_down     && mouse below current position
        CASE pick_key = &k_pg_up       && mouse above current position
        CASE pick_key = &k_c_pg_down   && mouse at bottom  on scroll bar
        CASE pick_key = &k_c_pg_up     && mouse at top  on scroll bar
      ENDCASE

    CASE mouse_stat = &jl_mouse_xnew   && left released + mouse on new
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_new    && left + mouse on new element
      list_return = &jl_goto_mouse

    CASE mouse_stat = &jl_mouse_select  && left + mouse on current element
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_xselect && left released + mouse on current
      __last_key = &k_enter
      pick_key = &k_enter

    CASE mouse_stat = &jl_mouse_left    && left + mouse outside of pick area
      list_return = &jl_continue
      IF mrow=ur-1
        pick_key = &k_up
      ELSE
        IF mrow=lr+1
          pick_key = &k_down
        ELSE
          list_return = &jl_ignore
        ENDIF
 
      ENDIF

    CASE mouse_stat = &jl_mouse_xleft   && left released + "         "
      list_return = &jl_ignore
    CASE mouse_stat = &jl_mouse_both    && left & right button hit
      list_return = &jl_ignore
  ENDCASE

  DO CASE
    CASE pick_key = &k_enter
      list_return = &jl_select
    CASE pick_key = &k_esc
      list_return = &jl_continue
  ENDCASE

  RETURN list_return
ENDPRO
