;***
;*** RESTlib public domain release March 1, 1995 (Jayson R. Minard)
;***
;*** ---- --- These comments may not be removed! --- ----
;***
;*** original RESTlib (c) 1993-95 Jayson R. Minard
;***                          CIS 72124,2343
;***                         iNET jayson@jerm.com
;***
;***
;*** This code may be used for any purpose as long as credit for the
;*** originating code is given back to Jayson Minard within the resulting
;*** product or its documentation.
;***

;
; This file is based on a FORCE internal include file given by SOPHCO Inc.
; for use within VList (now RESTlib)
;

                extrn   _$allocate:far
		extrn	_$deallocate:far

vlist_seg      segment public
                assume  cs:vlist_seg

stk_memory	equ	6

                public  __memory_alloc
__memory_alloc         proc    far

                push    bp               ;
                mov     bp, sp           ;
                push    bx               ;
                push    cx               ;
                                         ;
                mov     ah, 5            ; memory status
                call    _$allocate       ;
                mov     ax, [ bp ].6     ; AX is memory requested in bytes
                mov     bx, cx           ; BX is memory available in paragraphs
                mov     cl, 4            ;
                shr     ax, cl           ; convert AX to paragraphs

                push    bx
                mov     bx, [ bp ].6
                test    bx, 000Fh        ; are any low bits set?
                 jz     $no_round
                inc     ax               ; round up 1
$no_round:      inc     ax               ; add 1 for memory control block (MCB)
                pop     bx
                                         ;
                push    ax               ; store AX for later use
                                         ;
                add     ax, 0200h        ; now also add 0200h paragraphs to
                                         ; leave some 8k free ALWAYS
                cmp     ax, bx           ;
                ja      $fudged          ;
                                         ;
                pop     cx               ; now the old AX is in CX
                dec     cx               ; get rid of MCB paragraph
                mov     ah, 1            ; allocate static
                call    _$allocate       ;
                mov     ax, bx           ; ptr is DX:BX change to DX:AX
                jmp     $end_it          ;
                                         ;
$fudged:        pop     ax
                xor     ax, ax           ; clear pointer on bad allocate
                xor     dx, dx           ;
                                         ;
$end_it:                                 ;
                pop     cx               ;
                pop     bx               ;
                pop     bp               ;
                ret                      ;

__memory_alloc         endp

stk_handle	equ	6

                public  __memory_free
__memory_free           proc    far

		push	bp
		mov	bp,sp

	;---we're not to worry about NULL pointers
	
		mov	ax,[bp].stk_handle[2]
		xor	dx,dx
		or	dx,ax
		 jz	done_free

		call	_$deallocate

done_free:	pop	bp
		ret

__memory_free           endp

                public  __memory_left
__memory_left       proc    far
                push    bp               ;
                mov     bp, sp           ;
                push    cx               ;
                push    bx               ;
                                         ;
                mov     ah, 5            ; check memory status
                call    _$allocate       ;
                mov     ax, cx           ; AX is now memory left in paragraphs
                cmp     ax, 0200h        ; do we have at least 8k?
                jle     $less_some_k     ;

                sub     ax, 0200h        ; lower free mem count by 8k
                mov     cx, 010h         ; place 16 decimal in CX
                mul     cx               ; multiply AX by 16 and result is in
                                         ; DX:AX
                jmp     $mem_end

$less_some_k:   xor     dx, dx           ; lie and say we only have 0 if we
                xor     ax, ax           ; really have <= whatever K we allow
                                         ; as the minimum.
$mem_end:
                pop     bx               ;
                pop     cx               ;
                pop     bp               ;
                ret                      ;
__memory_left       endp

        
vlist_seg           ends

end

